NFSD(8)

NAME
nfsd - NFS service daemon

SYNOPSIS
/usr/sbin/rpc.nfsd [ -f exports-file ] [ -d facility ] [ -P port ] [ -Fhnprstv ] [ --debug facility ] [ --exports-file=file ] [ --foreground ] [ --help ] [ --allow-non-root ] [ --re-export ] [ --port port ] [ --version ] [ numservers ]

DESCRIPTION
The nfsd program is an NFS service daemon that handles client filesystem requests. Unlike on some other systems, nfsd operates as a normal user-level process. The server also differs from other NFS server implementations in that it mounts an entire file hierarchy not limited by the boundaries of physical file-systems. The implementation allows the clients read-only or read-write access to the file hierarchy of the server machine.

The mountd program starts an ancillary user-level mount daemon.

OPTIONS

-f or --exports-file
    This option specifies the exports file, listing the clients that this server is prepared to serve and parameters to apply to each such mount (see exports(5)). By default exports are read from /etc/exports.

-d facility or --debug facility
    Log operations verbosely. Legal values for facility are currently call for the logging of RPC calls and arguments, fhcache for the file handle cache operation, auth for the authentication routines, and ugid for the uid mapping code, if used. Debug messages will be logged to syslog(8) unless the daemon runs in the foreground.

-F or --foreground
    Unlike in normal operation, nfsd will not detach from the terminal when given this option. When debugging is requested, it will be sent to standard error.

-h or --help
    Provide a short help summary.

-n or --allow-non-root
    Allow incoming NFS requests to be honored even if they do not originate from reserved IP ports. Some older NFS client implementations require this. Some newer NFS client implementations don't believe in reserved port checking. This check can be turned off for individual hosts by specifying the insecure export option in /etc/exports.

-P portnum or --port portnum
    Makes nfsd listen on port portnum instead of the default port 2049.

-p or --promiscuous
    Put the server into promiscuous mode where it will serve any host on the network.

-r or --re-export
    Allow imported NFS file-systems to be exported. This can be used to turn a machine into an NFS multiplier. Caution should be used when re-exporting loopback NFS mounts because re-entering the mount point will result in deadlock between the NFS client and the NFS server.

-v or --version
    Report the current version number of the program.

numcopies
    This is an experimental feature that lets you run several instances of nfsd in parallel. When given a value of numcopies greater than one, nfsd will fork as many times as specified by this value. However, the servers do not share a common file handle cache, which makes certain file operations impossible.

    For this reason, nfsd will disallow all write operations when invoked with this option. Although this is very limiting, this feature may still prove useful for exporting public FTP areas or Usenet News spools. Note that (at best) you won't see any improvements when measuring throughput with a single reader, or with several readers on a single host whose NFS client implementation is single-threaded and does no read-ahead (as Linux's currently is).

SIGNALS
nfsd recognizes the following signals:

SIGHUP
    causes nfsd to re-read the export file and flush the file handle cache.

SIGUSR1
    When nfsd was invoked with debugging options, sending this signal toggles generation of debug information.

SIGIOT
    When compiled with with the -DCALL_PROFILING option, sending a SIGIOT to nfsd will cause dump the average execution times per NFS operation into /tmp/nfsd.profile.

SEE ALSO
exports(5), mountd(8), ugidd(8C)

AUTHORS
Mark Shand wrote the orignal unfsd. Don Becker extended unfsd to support authentication and allow read-write access and called it hnfs. Rick Sladkey added host matching, showmount -e support, mountd authentication, inetd support, and all of the portability and configuration code. Olaf Kirch fixed one or two security holes and other bugs, added the uid mapping and a couple of other things.